###
# Modern Albufeira Prolog Interpreter
#
# Warranty & Liability
# To the extent permitted by applicable law and unless explicitly
# otherwise agreed upon, XLOG Technologies AG makes no warranties
# regarding the provided information. XLOG Technologies AG assumes
# no liability that any problems might be solved with the information
# provided by XLOG Technologies AG.
#
# Rights & License
# All industrial property rights regarding the information - copyright
# and patent rights in particular - are the sole property of XLOG
# Technologies AG. If the company was not the originator of some
# excerpts, XLOG Technologies AG has at least obtained the right to
# reproduce, change and translate the information.
#
# Reproduction is restricted to the whole unaltered document. Reproduction
# of the information is only allowed for non-commercial uses. Selling,
# giving away or letting of the execution of the library is prohibited.
# The library can be distributed as part of your applications and libraries
# for execution provided this comment remains unchanged.
#
# Restrictions
# Only to be distributed with programs that add significant and primary
# functionality to the library. Not to be distributed with additional
# software intended to replace any components of the library.
#
# Trademarks
# Jekejeke is a registered trademark of XLOG Technologies AG.
##

from nova.core import (make_check, exec_build, deref,
       is_structure, add,  assoc_set, assoc_get,
       VAR_MASK_SEEN, VAR_MASK_SERNO, Item,
       stack_pop, stack_peek, stack_push,
       exec_unify, Compound, Variable, is_compound)


################################################################
# acyclic_term/1                                               #
################################################################

###
# acyclic_term(T): [TC2 8.3.11]
# The predicate succeeds when the Prolog term T is an acyclic term,
# otherwise the predicate fails.
##
def test_acyclic_term(args):
    alpha = exec_build(args[0])
    res = walk_acyclic(alpha, VAR_MASK_SEEN)
    walk_acyclic(alpha, 0)
    return not res


###
# Walk a Prolog term completely or partially.
#
# @param first The Prolog term.
# @param state The desired state.
# @return True if the walk was complete, otherwise false.
##
def walk_acyclic(first, state):
    stack = None
    while True:
        first = deref(first)
        if is_compound(first):
            if (first.walk & VAR_MASK_SEEN) != state:
                first.walk = (first.walk & ~VAR_MASK_SEEN) | state
                first.walk &= ~VAR_MASK_SERNO
                stack = stack_push(stack, first)
                first = first.args[0]
                continue
            elif ((first.walk & VAR_MASK_SERNO)
                  != len(first.args)):
                return True
        item = stack_peek(stack)
        while (item is not None and
               (item.walk & VAR_MASK_SERNO) == len(item.args) - 1):
            item.walk += 1
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return False
        else:
            item.walk += 1
            first = item.args[item.walk & VAR_MASK_SERNO]


################################################################
# sys_acyclic_decompose/2                                      #
################################################################

###
# sys_acyclic_decompose(X, T, L):
# The built-in succeeds in R with skeleton and substitution
# list cells so that the substitions applied to the skeletons gives
# identical the elements of the Prolog list L.
##
def test_sys_acyclic_decompose(args):
    alpha = exec_build(args[0])
    vmap = {}
    back = None
    res = None
    while (is_structure(alpha) and
           alpha.functor == "." and
           len(alpha.args) == 2):
        temp = deref(alpha.args[0])
        temp = walk_decom(vmap, temp)
        temp = Compound(".", [temp, NotImplemented])
        if back is None:
            res = temp
        else:
            back.args[1] = temp
        back = temp
        alpha = deref(alpha.args[1])
    if back is None:
        res = "[]"
    else:
        back.args[1] = "[]"
    return exec_unify(args[1], res)


###
# Walk a Prolog term completely.
#
# @param vmap The compound map.
# @param first The Prolog term.
# @return The decomp.
##
def walk_decom(vmap, first):
    stack = None
    subst = "[]"
    while True:
        first = deref(first)
        if is_compound(first):
            peek = assoc_get(vmap, first)
            if peek is NotImplemented:
                vmap = assoc_set(vmap, first, None)
                peek = Compound(first.functor,
                           [NotImplemented] * len(first.args))
                item = Item(first, peek, 0)
                stack = stack_push(stack, item)
                first = first.args[0]
                continue
            else:
                if peek is None:
                    peek = Variable()
                    vmap = assoc_set(vmap, first, peek)
                first = peek
        item = stack_peek(stack)
        while (item is not None and
               item.idx == len(item.first.args) - 1):
            item.second.args[item.idx] = first
            first = item.second
            peek = assoc_get(vmap, item.first)
            if peek is None:
                vmap = assoc_set(vmap, item.first, first)
            else:
                first = Compound("=", [peek, first])
                subst = Compound(".", [first, subst])
                first = peek
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return Compound(".", [first,subst])
        else:
            item.second.args[item.idx] = first
            item.idx += 1
            first = item.first.args[item.idx]


#######################################################################
# Cyc Lib Init                                                        #
#######################################################################

def main():
    add("acyclic_term", 1, make_check(test_acyclic_term))
    add("sys_acyclic_decompose", 2, make_check(test_sys_acyclic_decompose))
